# -*- coding: ISO-8859-1 -*-
# generated by wxGlade 0.3.5.1 on Mon Jul 04 11:37:46 2005

# This file is part of Platitude

""" The lattice painting view.
"""

__copyright__ = 'Copyright 2005, Ned Batchelder, All rights reserved.'
__author__ = 'Ned Batchelder'
__revision__ = '$Rev: 31 $'

import wx

# begin wxGlade: dependencies
# end wxGlade

class LatCanvas(wx.ScrolledWindow):
    def __init__(self, *args, **kwds):
        # begin wxGlade: LatCanvas.__init__
        kwds["style"] = wx.TAB_TRAVERSAL
        wx.ScrolledWindow.__init__(self, *args, **kwds)

        self.__set_properties()
        self.__do_layout()
        # end wxGlade

        self.cell = 20
        self.thick = 10
        self.margin = 20

        self.CreateTiles()        
        self.SetModel(None)
        
        self.Bind(wx.EVT_PAINT, self.OnPaint)
        self.Bind(wx.EVT_MOTION, self.OnMotion)
        self.Bind(wx.EVT_LEFT_DOWN, self.OnLeftButton)

        self.lit = None
        
    def __set_properties(self):
        # begin wxGlade: LatCanvas.__set_properties
        self.SetScrollRate(10, 10)
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: LatCanvas.__do_layout
        pass
        # end wxGlade

    def CreateTiles(self):
        self.tiles = {}

        marg0 = (self.cell - self.thick) / 2
        marg1 = (self.cell - marg0)
        cell = self.cell

        for c in 'GTLJ-|HI+ ':
            bmp = wx.EmptyBitmap(cell, cell)
            dc = wx.MemoryDC()
            dc.SelectObject(bmp)
            dc.SetBackground(wx.Brush(self.GetBackgroundColour()))
            dc.Clear()

            self.dc = dc
            
            if c == 'G':
                self.poly(
                    (0, marg0, cell), (1, marg0, marg0), (1, cell, marg0),
                    (0, cell, marg1), (1, marg1, marg1), (1, marg1, cell)
                    )
            elif c == 'T':
                self.poly(
                    (0, 0, marg0), (1, marg1, marg0), (1, marg1, cell),
                    (0, marg0, cell), (1, marg0, marg1), (1, 0, marg1)
                    )
            elif c == 'L':
                self.poly(
                    (0, marg0, 0), (1, marg0, marg1), (1, cell, marg1),
                    (0, cell, marg0), (1, marg1, marg0), (1, marg1, 0)
                    )
            elif c == 'J':
                self.poly(
                    (0, 0, marg0), (1, marg0, marg0), (1, marg0, 0),
                    (0, marg1, 0), (1, marg1, marg1), (1, 0, marg1)
                    )
            elif c == '-':
                self.poly(
                    (0, 0, marg0), (1, cell, marg0),
                    (0, cell, marg1), (1, 0, marg1)
                    )
            elif c == '|':
                self.poly(
                    (0, marg0, 0), (1, marg0, cell),
                    (0, marg1, cell), (1, marg1, 0)
                    )
            elif c == 'I':
                self.poly(
                    (0, 0, marg0), (1, cell, marg0),
                    (0, cell, marg1), (1, 0, marg1)
                    )
                self.poly(
                    (0, marg0, 0), (1, marg0, cell),
                    (0, marg1, cell), (1, marg1, 0)
                    )
                self.shadow(marg1+1, marg0+1, marg1+1, marg1)
            elif c == 'H':
                self.poly(
                    (0, marg0, 0), (1, marg0, cell),
                    (0, marg1, cell), (1, marg1, 0)
                    )
                self.poly(
                    (0, 0, marg0), (1, cell, marg0),
                    (0, cell, marg1), (1, 0, marg1)
                    )
                self.shadow(marg0+1, marg1+1, marg1, marg1+1)
            elif c == '+':
                self.line(0, marg0, marg0, marg0)
                self.line(0, marg1, marg0, marg1)
                self.line(marg1, marg0, cell, marg0)
                self.line(marg1, marg1, cell, marg1)
                self.line(marg0, 0, marg0, marg0)
                self.line(marg1, 0, marg1, marg0)
                self.line(marg0, marg1, marg0, cell)
                self.line(marg1, marg1, marg1, cell)

            self.tiles[c] = bmp
            
    def SetModel(self, model):
        self.model = model

        if self.model:
            self.size = self.model.size
            self.maxWidth = (self.size[0] * self.cell) + 2*self.margin
            self.maxHeight = (self.size[1] * self.cell) + 2*self.margin
        else:
            self.maxWidth = self.maxHeight = 0

        self.SetScrollbars(20, 20, self.maxWidth/20, self.maxHeight/20)
        self.Redraw()
        
    def Redraw(self):
        self.buffer = wx.EmptyBitmap(self.maxWidth, self.maxHeight)
        dc = wx.BufferedDC(None, self.buffer)
        dc.SetBackground(wx.Brush(self.GetBackgroundColour()))
        dc.Clear()
        self.DoDrawing(dc)
        self.Refresh()

    def OnPaint(self, ev):
        dc = wx.BufferedPaintDC(self, self.buffer)

    def OnMotion(self, ev):
        if not self.model:
            return
        self.hit(ev)
        
    def hit(self, ev):        
        x, y = self.ConvertEventCoords(ev)
        x -= self.margin
        y -= self.margin
        # x and y are now aligned on cells, but our work is much easier
        # if we offset it by marg0
        gap = self.cell - self.thick
        x += gap/2
        y += gap/2
        remx = x % self.cell
        remy = y % self.cell
        cellx = (x / self.cell)-1
        celly = (y / self.cell)-1
        ingap = (
            cellx >= 0 and celly >= 0 and
            cellx < self.model.size[0]-1 and
            celly < self.model.size[1]-1 and
            remx < gap and remy < gap)
        #if ingap:
        #    print cellx, celly
        #    print '%s%s\n%s%s' % (
        #        self.model.gtlj[celly][cellx], self.model.gtlj[celly][cellx+1],
        #        self.model.gtlj[celly+1][cellx], self.model.gtlj[celly+1][cellx+1],
        #        )
        return ingap, cellx, celly

    def OnLeftButton(self, ev):
        if not self.model:
            return
        ingap, x, y = self.hit(ev)
        if ingap:
            self.model.InvertFour(x, y)
            self.Redraw()
        else:
            pass #print self.model.Cycle(x+1, y+1)

    def ConvertEventCoords(self, ev):
        """ Convert physical mouse coords to scrolled mouse coords. """
        xView, yView = self.GetViewStart()
        xDelta, yDelta = self.GetScrollPixelsPerUnit()
        return (ev.GetX() + (xView * xDelta),
                ev.GetY() + (yView * yDelta))

    def line(self, x0, y0, x1, y1, x2=None, y2=None):
        self.dc.SetPen(wx.BLACK_PEN)
        self.dc.DrawLine(x0, y0, x1, y1)
        if x2 != None:
            self.dc.DrawLine(x1, y1, x2, y2)
            self.dc.DrawPoint(x2, y2)
        else:
            self.dc.DrawPoint(x1, y1)

    def poly(self, *pts):
        self.dc.SetPen(wx.WHITE_PEN)
        self.dc.SetBrush(wx.WHITE_BRUSH)
        self.dc.DrawPolygon([ (pt[1], pt[2]) for pt in pts ])
        self.dc.SetPen(wx.BLACK_PEN)
        for i in range(1, len(pts)):
            if pts[i][0] == 1:
                self.dc.DrawLine(pts[i-1][1], pts[i-1][2], pts[i][1], pts[i][2])
                self.dc.DrawPoint(pts[i][1], pts[i][2])

    def shadow(self, *pts):
        self.dc.SetPen(wx.Pen(wx.Color(220,220,220)))
        self.dc.DrawLine(*pts)
    
    def DoDrawing(self, dc, printing=False):
        dc.BeginDrawing()
        self.dc = dc
        if self.model:
            cell = self.cell

            x = self.margin
            y = self.margin
            for line in self.model.gtlj:
                for c in line:
                    self.dc.DrawBitmap(self.tiles[c], x, y)
                    x += cell
                y += cell
                x = self.margin

        self.dc = None
        dc.EndDrawing()

# end of class LatCanvas
